// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/DiagnosticsEthernetConfigurationInformation.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__DIAGNOSTICS_ETHERNET_CONFIGURATION_INFORMATION__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__DIAGNOSTICS_ETHERNET_CONFIGURATION_INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__DiagnosticsEthernetConfigurationInformation __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__DiagnosticsEthernetConfigurationInformation __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DiagnosticsEthernetConfigurationInformation_
{
  using Type = DiagnosticsEthernetConfigurationInformation_<ContainerAllocator>;

  explicit DiagnosticsEthernetConfigurationInformation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ip_address = "";
      this->netmask = "";
      this->vlan = 0;
      this->port = 0;
    }
  }

  explicit DiagnosticsEthernetConfigurationInformation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : ip_address(_alloc),
    netmask(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ip_address = "";
      this->netmask = "";
      this->vlan = 0;
      this->port = 0;
    }
  }

  // field types and members
  using _ip_address_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _ip_address_type ip_address;
  using _netmask_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _netmask_type netmask;
  using _vlan_type =
    uint16_t;
  _vlan_type vlan;
  using _port_type =
    uint16_t;
  _port_type port;

  // setters for named parameter idiom
  Type & set__ip_address(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->ip_address = _arg;
    return *this;
  }
  Type & set__netmask(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->netmask = _arg;
    return *this;
  }
  Type & set__vlan(
    const uint16_t & _arg)
  {
    this->vlan = _arg;
    return *this;
  }
  Type & set__port(
    const uint16_t & _arg)
  {
    this->port = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__DiagnosticsEthernetConfigurationInformation
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__DiagnosticsEthernetConfigurationInformation
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DiagnosticsEthernetConfigurationInformation_ & other) const
  {
    if (this->ip_address != other.ip_address) {
      return false;
    }
    if (this->netmask != other.netmask) {
      return false;
    }
    if (this->vlan != other.vlan) {
      return false;
    }
    if (this->port != other.port) {
      return false;
    }
    return true;
  }
  bool operator!=(const DiagnosticsEthernetConfigurationInformation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DiagnosticsEthernetConfigurationInformation_

// alias to use template instance with default allocator
using DiagnosticsEthernetConfigurationInformation =
  off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__DIAGNOSTICS_ETHERNET_CONFIGURATION_INFORMATION__STRUCT_HPP_
