// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from off_highway_premium_radar_sample_msgs:msg/EgoVehicleData.idl
// generated code does not contain a copyright notice
#include "off_highway_premium_radar_sample_msgs/msg/detail/ego_vehicle_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `velocity`
#include "geometry_msgs/msg/detail/twist_with_covariance__functions.h"
// Member `acceleration`
#include "geometry_msgs/msg/detail/accel__functions.h"

bool
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__init(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * msg)
{
  if (!msg) {
    return false;
  }
  // velocity
  if (!geometry_msgs__msg__TwistWithCovariance__init(&msg->velocity)) {
    off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__fini(msg);
    return false;
  }
  // acceleration
  if (!geometry_msgs__msg__Accel__init(&msg->acceleration)) {
    off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__fini(msg);
    return false;
  }
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__fini(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * msg)
{
  if (!msg) {
    return;
  }
  // velocity
  geometry_msgs__msg__TwistWithCovariance__fini(&msg->velocity);
  // acceleration
  geometry_msgs__msg__Accel__fini(&msg->acceleration);
}

bool
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__are_equal(const off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * lhs, const off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // velocity
  if (!geometry_msgs__msg__TwistWithCovariance__are_equal(
      &(lhs->velocity), &(rhs->velocity)))
  {
    return false;
  }
  // acceleration
  if (!geometry_msgs__msg__Accel__are_equal(
      &(lhs->acceleration), &(rhs->acceleration)))
  {
    return false;
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__copy(
  const off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * input,
  off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * output)
{
  if (!input || !output) {
    return false;
  }
  // velocity
  if (!geometry_msgs__msg__TwistWithCovariance__copy(
      &(input->velocity), &(output->velocity)))
  {
    return false;
  }
  // acceleration
  if (!geometry_msgs__msg__Accel__copy(
      &(input->acceleration), &(output->acceleration)))
  {
    return false;
  }
  return true;
}

off_highway_premium_radar_sample_msgs__msg__EgoVehicleData *
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * msg = (off_highway_premium_radar_sample_msgs__msg__EgoVehicleData *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData));
  bool success = off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__destroy(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence__init(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * data = NULL;

  if (size) {
    data = (off_highway_premium_radar_sample_msgs__msg__EgoVehicleData *)allocator.zero_allocate(size, sizeof(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence__fini(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence *
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence * array = (off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence__destroy(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence__are_equal(const off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence * lhs, const off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence__copy(
  const off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence * input,
  off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(off_highway_premium_radar_sample_msgs__msg__EgoVehicleData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * data =
      (off_highway_premium_radar_sample_msgs__msg__EgoVehicleData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
