// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/LocationAttributesPacket.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_PACKET__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_PACKET__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/location_attributes_packet__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'sensor_modulation_performance'
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_modulation_performance__traits.hpp"
// Member 'misalignment'
#include "off_highway_premium_radar_sample_msgs/msg/detail/misalignment_packet__traits.hpp"
// Member 'interference_indicator'
#include "off_highway_premium_radar_sample_msgs/msg/detail/interference_indicator__traits.hpp"
// Member 'sensor_field_of_view'
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_field_of_view__traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LocationAttributesPacket & msg,
  std::ostream & out)
{
  out << "{";
  // member: sensor_modulation_performance
  {
    out << "sensor_modulation_performance: ";
    to_flow_style_yaml(msg.sensor_modulation_performance, out);
    out << ", ";
  }

  // member: misalignment
  {
    out << "misalignment: ";
    to_flow_style_yaml(msg.misalignment, out);
    out << ", ";
  }

  // member: interference_indicator
  {
    out << "interference_indicator: ";
    to_flow_style_yaml(msg.interference_indicator, out);
    out << ", ";
  }

  // member: sensor_field_of_view
  {
    out << "sensor_field_of_view: ";
    to_flow_style_yaml(msg.sensor_field_of_view, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LocationAttributesPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: sensor_modulation_performance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_modulation_performance:\n";
    to_block_style_yaml(msg.sensor_modulation_performance, out, indentation + 2);
  }

  // member: misalignment
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "misalignment:\n";
    to_block_style_yaml(msg.misalignment, out, indentation + 2);
  }

  // member: interference_indicator
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_indicator:\n";
    to_block_style_yaml(msg.interference_indicator, out, indentation + 2);
  }

  // member: sensor_field_of_view
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_field_of_view:\n";
    to_block_style_yaml(msg.sensor_field_of_view, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LocationAttributesPacket & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket>()
{
  return "off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket>()
{
  return "off_highway_premium_radar_sample_msgs/msg/LocationAttributesPacket";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket>
  : std::integral_constant<bool, has_fixed_size<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator>::value && has_fixed_size<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket>::value && has_fixed_size<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView>::value && has_fixed_size<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance>::value> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket>
  : std::integral_constant<bool, has_bounded_size<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator>::value && has_bounded_size<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket>::value && has_bounded_size<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView>::value && has_bounded_size<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance>::value> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::LocationAttributesPacket>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_PACKET__TRAITS_HPP_
