// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorStateInformation.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_STATE_INFORMATION__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_STATE_INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_state_information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SensorStateInformation & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: lgp_version
  {
    out << "lgp_version: ";
    rosidl_generator_traits::value_to_yaml(msg.lgp_version, out);
    out << ", ";
  }

  // member: sensor_state
  {
    out << "sensor_state: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_state, out);
    out << ", ";
  }

  // member: customer_version
  {
    out << "customer_version: ";
    rosidl_generator_traits::value_to_yaml(msg.customer_version, out);
    out << ", ";
  }

  // member: internal_version
  {
    if (msg.internal_version.size() == 0) {
      out << "internal_version: []";
    } else {
      out << "internal_version: [";
      size_t pending_items = msg.internal_version.size();
      for (auto item : msg.internal_version) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SensorStateInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: lgp_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lgp_version: ";
    rosidl_generator_traits::value_to_yaml(msg.lgp_version, out);
    out << "\n";
  }

  // member: sensor_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_state: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_state, out);
    out << "\n";
  }

  // member: customer_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "customer_version: ";
    rosidl_generator_traits::value_to_yaml(msg.customer_version, out);
    out << "\n";
  }

  // member: internal_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.internal_version.size() == 0) {
      out << "internal_version: []\n";
    } else {
      out << "internal_version:\n";
      for (auto item : msg.internal_version) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SensorStateInformation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::SensorStateInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::SensorStateInformation & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::SensorStateInformation>()
{
  return "off_highway_premium_radar_sample_msgs::msg::SensorStateInformation";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::SensorStateInformation>()
{
  return "off_highway_premium_radar_sample_msgs/msg/SensorStateInformation";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::SensorStateInformation>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::SensorStateInformation>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::SensorStateInformation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_STATE_INFORMATION__TRAITS_HPP_
