// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from off_highway_premium_radar_sample_msgs:msg/LocationAttributesHeader.idl
// generated code does not contain a copyright notice
#include "off_highway_premium_radar_sample_msgs/msg/detail/location_attributes_header__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `start_measurement`
#include "off_highway_premium_radar_sample_msgs/msg/detail/time__functions.h"
// Member `operation_mode`
#include "off_highway_premium_radar_sample_msgs/msg/detail/operation_mode__functions.h"

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__init(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * msg)
{
  if (!msg) {
    return false;
  }
  // lgp_version
  // block_counter
  // start_measurement
  if (!off_highway_premium_radar_sample_msgs__msg__Time__init(&msg->start_measurement)) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__fini(msg);
    return false;
  }
  // operation_mode
  if (!off_highway_premium_radar_sample_msgs__msg__OperationMode__init(&msg->operation_mode)) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__fini(msg);
    return false;
  }
  // data_measured
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__fini(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * msg)
{
  if (!msg) {
    return;
  }
  // lgp_version
  // block_counter
  // start_measurement
  off_highway_premium_radar_sample_msgs__msg__Time__fini(&msg->start_measurement);
  // operation_mode
  off_highway_premium_radar_sample_msgs__msg__OperationMode__fini(&msg->operation_mode);
  // data_measured
}

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__are_equal(const off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * lhs, const off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // lgp_version
  if (lhs->lgp_version != rhs->lgp_version) {
    return false;
  }
  // block_counter
  if (lhs->block_counter != rhs->block_counter) {
    return false;
  }
  // start_measurement
  if (!off_highway_premium_radar_sample_msgs__msg__Time__are_equal(
      &(lhs->start_measurement), &(rhs->start_measurement)))
  {
    return false;
  }
  // operation_mode
  if (!off_highway_premium_radar_sample_msgs__msg__OperationMode__are_equal(
      &(lhs->operation_mode), &(rhs->operation_mode)))
  {
    return false;
  }
  // data_measured
  if (lhs->data_measured != rhs->data_measured) {
    return false;
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__copy(
  const off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * input,
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * output)
{
  if (!input || !output) {
    return false;
  }
  // lgp_version
  output->lgp_version = input->lgp_version;
  // block_counter
  output->block_counter = input->block_counter;
  // start_measurement
  if (!off_highway_premium_radar_sample_msgs__msg__Time__copy(
      &(input->start_measurement), &(output->start_measurement)))
  {
    return false;
  }
  // operation_mode
  if (!off_highway_premium_radar_sample_msgs__msg__OperationMode__copy(
      &(input->operation_mode), &(output->operation_mode)))
  {
    return false;
  }
  // data_measured
  output->data_measured = input->data_measured;
  return true;
}

off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader *
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * msg = (off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader));
  bool success = off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__destroy(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence__init(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * data = NULL;

  if (size) {
    data = (off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader *)allocator.zero_allocate(size, sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence__fini(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence *
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence * array = (off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence__destroy(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence__are_equal(const off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence * lhs, const off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence__copy(
  const off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence * input,
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader * data =
      (off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
