// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from off_highway_premium_radar_sample_msgs:msg/LocationAttributesPacket.idl
// generated code does not contain a copyright notice
#include "off_highway_premium_radar_sample_msgs/msg/detail/location_attributes_packet__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `sensor_modulation_performance`
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_modulation_performance__functions.h"
// Member `misalignment`
#include "off_highway_premium_radar_sample_msgs/msg/detail/misalignment_packet__functions.h"
// Member `interference_indicator`
#include "off_highway_premium_radar_sample_msgs/msg/detail/interference_indicator__functions.h"
// Member `sensor_field_of_view`
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_field_of_view__functions.h"

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__init(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * msg)
{
  if (!msg) {
    return false;
  }
  // sensor_modulation_performance
  if (!off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance__init(&msg->sensor_modulation_performance)) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__fini(msg);
    return false;
  }
  // misalignment
  if (!off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket__init(&msg->misalignment)) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__fini(msg);
    return false;
  }
  // interference_indicator
  if (!off_highway_premium_radar_sample_msgs__msg__InterferenceIndicator__init(&msg->interference_indicator)) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__fini(msg);
    return false;
  }
  // sensor_field_of_view
  if (!off_highway_premium_radar_sample_msgs__msg__SensorFieldOfView__init(&msg->sensor_field_of_view)) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__fini(msg);
    return false;
  }
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__fini(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * msg)
{
  if (!msg) {
    return;
  }
  // sensor_modulation_performance
  off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance__fini(&msg->sensor_modulation_performance);
  // misalignment
  off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket__fini(&msg->misalignment);
  // interference_indicator
  off_highway_premium_radar_sample_msgs__msg__InterferenceIndicator__fini(&msg->interference_indicator);
  // sensor_field_of_view
  off_highway_premium_radar_sample_msgs__msg__SensorFieldOfView__fini(&msg->sensor_field_of_view);
}

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__are_equal(const off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * lhs, const off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // sensor_modulation_performance
  if (!off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance__are_equal(
      &(lhs->sensor_modulation_performance), &(rhs->sensor_modulation_performance)))
  {
    return false;
  }
  // misalignment
  if (!off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket__are_equal(
      &(lhs->misalignment), &(rhs->misalignment)))
  {
    return false;
  }
  // interference_indicator
  if (!off_highway_premium_radar_sample_msgs__msg__InterferenceIndicator__are_equal(
      &(lhs->interference_indicator), &(rhs->interference_indicator)))
  {
    return false;
  }
  // sensor_field_of_view
  if (!off_highway_premium_radar_sample_msgs__msg__SensorFieldOfView__are_equal(
      &(lhs->sensor_field_of_view), &(rhs->sensor_field_of_view)))
  {
    return false;
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__copy(
  const off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * input,
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * output)
{
  if (!input || !output) {
    return false;
  }
  // sensor_modulation_performance
  if (!off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance__copy(
      &(input->sensor_modulation_performance), &(output->sensor_modulation_performance)))
  {
    return false;
  }
  // misalignment
  if (!off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket__copy(
      &(input->misalignment), &(output->misalignment)))
  {
    return false;
  }
  // interference_indicator
  if (!off_highway_premium_radar_sample_msgs__msg__InterferenceIndicator__copy(
      &(input->interference_indicator), &(output->interference_indicator)))
  {
    return false;
  }
  // sensor_field_of_view
  if (!off_highway_premium_radar_sample_msgs__msg__SensorFieldOfView__copy(
      &(input->sensor_field_of_view), &(output->sensor_field_of_view)))
  {
    return false;
  }
  return true;
}

off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket *
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * msg = (off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket));
  bool success = off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__destroy(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence__init(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * data = NULL;

  if (size) {
    data = (off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket *)allocator.zero_allocate(size, sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence__fini(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence *
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence * array = (off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence__destroy(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence__are_equal(const off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence * lhs, const off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence__copy(
  const off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence * input,
  off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket * data =
      (off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__LocationAttributesPacket__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
