// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from off_highway_premium_radar_sample_msgs:msg/MisalignmentPacket.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MISALIGNMENT_PACKET__STRUCT_H_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MISALIGNMENT_PACKET__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/MisalignmentPacket in the package off_highway_premium_radar_sample_msgs.
/**
  * Comments provide naming from Technical Customer Information
 */
typedef struct off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket
{
  /// LocAtr_ThetaMalAng
  float theta;
  /// LocAtr_ThetaMalAngVar
  float theta_variance;
  /// LocAtr_PhiMalAng
  float phi;
  /// LocAtr_PhiMalAngVar
  float phi_variance;
  /// LocAtr_PhiMalAngEme
  float phi_eme;
  /// LocAtr_PhiMalAngEmeVar
  float phi_eme_variance;
  /// LocAtr_MalStatus
  uint16_t status;
  /// LocAtr_MalStatusEme
  uint16_t status_eme;
  /// LocAtr_PercNegativeTheta
  float percent_negative_theta;
  /// LocAtr_MinThetaMalSOs
  float min_theta_sos;
  /// LocAtr_MaxThetaMalSOs
  float max_theta_sos;
  /// LocAtr_VarThetaMalSOs
  float theta_sos_variance;
  /// LocAtr_MeanThetaMalSOs
  float theta_sos_mean;
  /// LocAtr_MinPhiMalSOs
  float min_phi_sos;
  /// LocAtr_MaxPhiMalSOs
  float max_phi_sos;
  /// LocAtr_VarPhiMalSOs
  float phi_sos_variance;
  /// LocAtr_MeanPhiMalSOs
  float phi_sos_mean;
  /// LocAtr_SpreadPhiMalSOs
  float phi_sos_spread;
  /// LocAtr_NumSOs
  uint16_t num_sos;
  /// LocAtr_NumEmeLocs
  uint16_t num_eme;
} off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket;

// Struct for a sequence of off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket.
typedef struct off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket__Sequence
{
  off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MISALIGNMENT_PACKET__STRUCT_H_
