// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorFieldOfView.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FIELD_OF_VIEW__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FIELD_OF_VIEW__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_field_of_view__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SensorFieldOfView & msg,
  std::ostream & out)
{
  out << "{";
  // member: fov
  {
    if (msg.fov.size() == 0) {
      out << "fov: []";
    } else {
      out << "fov: [";
      size_t pending_items = msg.fov.size();
      for (auto item : msg.fov) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: azimuth
  {
    if (msg.azimuth.size() == 0) {
      out << "azimuth: []";
    } else {
      out << "azimuth: [";
      size_t pending_items = msg.azimuth.size();
      for (auto item : msg.azimuth) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: elevation_range_scaling
  {
    if (msg.elevation_range_scaling.size() == 0) {
      out << "elevation_range_scaling: []";
    } else {
      out << "elevation_range_scaling: [";
      size_t pending_items = msg.elevation_range_scaling.size();
      for (auto item : msg.elevation_range_scaling) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: elevation
  {
    if (msg.elevation.size() == 0) {
      out << "elevation: []";
    } else {
      out << "elevation: [";
      size_t pending_items = msg.elevation.size();
      for (auto item : msg.elevation) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SensorFieldOfView & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: fov
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.fov.size() == 0) {
      out << "fov: []\n";
    } else {
      out << "fov:\n";
      for (auto item : msg.fov) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: azimuth
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.azimuth.size() == 0) {
      out << "azimuth: []\n";
    } else {
      out << "azimuth:\n";
      for (auto item : msg.azimuth) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: elevation_range_scaling
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.elevation_range_scaling.size() == 0) {
      out << "elevation_range_scaling: []\n";
    } else {
      out << "elevation_range_scaling:\n";
      for (auto item : msg.elevation_range_scaling) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: elevation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.elevation.size() == 0) {
      out << "elevation: []\n";
    } else {
      out << "elevation:\n";
      for (auto item : msg.elevation) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SensorFieldOfView & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView>()
{
  return "off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView>()
{
  return "off_highway_premium_radar_sample_msgs/msg/SensorFieldOfView";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::SensorFieldOfView>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FIELD_OF_VIEW__TRAITS_HPP_
